---
title: Firefox 70 for developers
slug: Mozilla/Firefox/Releases/70
tags:
  - '70'
  - Firefox
  - Mozilla
  - Release
---
<p>{{FirefoxSidebar}}</p>

<p class="summary">This article provides information about the changes in Firefox 70 that will affect developers. Firefox 70 was released on October 22, 2019.</p>

<h2 id="Changes_for_web_developers">Changes for web developers</h2>

<h3 id="Developer_tools">Developer tools</h3>

<h4 id="Debugger_updates">Debugger updates</h4>

<ul>
 <li>In the <a class="gr-progress" href="/en-US/docs/Tools/Debugger">Debugger</a> you can now set breakpoints for <a href="/en-US/docs/Tools/Debugger/Break_on_DOM_mutation">DOM Mutation</a>, so execution will pause when a node or its attibutes are changed or when a node is removed from the DOM ({{bug(1576219)}}).</li>
 <li>The Debugger now shows an overlay on the page when it is paused, with basic stepping buttons to let you step and continue ({{bug(1574646)}}).</li>
 <li>The Debugger now shows sources that already got discarded by the engine (usually scripts that execute once during page load), so you can properly set breakpoints to debug when they execute next ({{bug(1572280)}}).</li>
 <li>The Debugger's <a href="/en-US/docs/Tools/Debugger/Using_the_Debugger_map_scopes_feature">scopes panel</a> grouping has been simplified, consolidating additional scopes previously shown above the top level function (e.g. blocks created by <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/let">let</a></code>, <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/with">with</a></code>, or <a href="/en-US/docs/Web/JavaScript/Reference/Statements/if...else"><code>if</code>/<code>else</code></a>) ({{bug(1448166)}})</li>
 <li>The Debugger now retains the currently selected and expanded variables in the <a href="/en-US/docs/Tools/Debugger/Using_the_Debugger_map_scopes_feature">scopes panel</a> while stepping ({{bug(1405402)}}).</li>
 <li>The Debugger now handles stepping over async functions correctly, making <a href="/en-US/docs/Web/JavaScript/Reference/Statements/async_function">asynchronous function</a> debugging easier ({{bug(1570178)}}).</li>
 <li>When debugging in <a href="https://support.mozilla.org/en-US/kb/containers">Container sessions</a> (useful for testing different logins), the sources in the debugger are now shown correctly ({{bug(1375036)}}).</li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/debugger">debugger</a></code> statements can be now disabled in the Debugger by setting a breakpoint on them and switching the breakpoints to "Never pause here" ({{bug(925269)}}).</li>
 <li>WebExtensions developers can inspect <code>browser.storage.local</code> from the Extension Storage item under the Storage tab ({{bug(1585499)}}).</li>
</ul>

<h4 id="Other_updates">Other updates</h4>

<ul>
 <li>An icon will be displayed next to inactive CSS properties in the <a href="/en-US/docs/Tools/Page_Inspector/UI_Tour#Rules_view">Rules view</a> of the <a href="/en-US/docs/Tools/Page_Inspector">Page Inspector</a>, which you can hover over to get information on why it is inactive ({{bug(1306054)}}).</li>
 <li>In the <a href="/en-US/docs/Tools/Page_Inspector/UI_Tour#Rules_view">CSS Rules view</a>, the <a href="/en-US/docs/Tools/Page_Inspector/How_to/Inspect_and_select_colors">color picker</a> on foreground colors now tells you whether its contrast with the background color meets accessibility conformance criteria ({{bug(1478156)}}).</li>
 <li>The <a href="/en-US/docs/Tools/Accessibility_inspector">Accessibility inspector</a>'s <a href="/en-US/docs/Tools/Accessibility_inspector#Check_for_accessibility_issues">Check for issues</a> dropdown now includes keyboard accessibility checks ({{bug(1564968)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>Firefox can now suggest securely-generated passwords to the user in the following situations:
  <ul>
   <li>An {{HTMLelement("input")}} element has the <code>autocomplete="new-password"</code> attribute value.</li>
   <li>The user opens the context menu on any password input element, even if it is not intended for new passwords.</li>
  </ul>
 </li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>Opacity values like for {{cssxref("opacity")}} or {{SVGAttr("stop-opacity")}} can now be percentages ({{Bug(1562086)}}).</li>
 <li>{{cssxref("grid-auto-columns")}} and {{cssxref("grid-auto-rows")}} now accept multiple track-size values ({{Bug(1339672)}}).</li>
 <li>A number of text-related CSS properties have been enabled by default ({{bug(1573631)}}):
  <ul>
   <li>{{cssxref("text-decoration-thickness")}}.</li>
   <li>{{cssxref("text-underline-offset")}}.</li>
   <li>{{cssxref("text-decoration-skip-ink")}}. The default value is <code>auto</code>, which means that by default underlines and overlines are now interrupted where they would otherwise cross over a {{Glossary("glyph")}}.</li>
  </ul>
 </li>
 <li>The {{cssxref("display")}} property now accepts two keyword values representing the inner and outer display type ({{Bug(1038294)}}, {{Bug(1105868)}} and {{Bug(1557825)}}).</li>
 <li>The {{cssxref("font-size")}} property now accepts the new keyword value <code>xxx-large</code>. ({{Bug(1553545)}}).</li>
 <li>The {{cssxref(":visited")}} pseudo-class no longer matches {{htmlelement("link")}} elements, for logic and performance reasons ({{bug(1572246)}}; see <span class="F0XO1GC-mb-Z" id="t-t"><a href="https://groups.google.com/forum/#!msg/mozilla.dev.platform/1NP6oJzK6zg/ftAz_TajAAAJ">Intent to ship: Make &lt;link&gt; elements always unvisited</a> and </span><a href="https://github.com/w3c/csswg-drafts/issues/3817">[selectors] :link and &lt;link&gt;</a> for more reasoning as to why).</li>
 <li>We now support an <code>auto</code> value for the {{cssxref("quotes")}} property ({{bug(1421938)}}).</li>
 <li>Stylesheets contained in {{htmlelement("style")}} elements are now cached for reuse, to improve performance ({{bug(1480146)}}). Note that this currently doesn't include stylesheets that contain <code>@import</code> rules.</li>
 <li>The <code>&lt;ratio&gt;</code> type now accepts <code>&lt;number&gt;/&lt;number&gt;</code> or a single <code>&lt;number&gt;</code> as a value. ({{bug(1565562)}}).</li>
</ul>

<h4 id="Removals">Removals</h4>

<ul>
 <li>We have retired support for 3-valued &lt;position&gt; (excluding background)({{Bug(1559276)}}). <a href="https://www.fxsitecompat.dev/en-CA/docs/2019/3-valued-css-position-is-no-longer-supported-except-for-background-position/">See site compat note</a>.</li>
 <li>The <code>none</code> value is now invalid in {{cssxref("counter")}} / {{cssxref("counters")}} — a change which makes the Level 3 spec match CSS 2.1 {{Bug(1576821)}}).</li>
</ul>

<h3 id="SVG">SVG</h3>

<ul>
 <li>Cut, copy, and paste events are now dispatched to SVG graphics elements ({{bug(1569474)}}).</li>
</ul>

<h3 id="MathML">MathML</h3>

<ul>
 <li>The deprecated <code> mode</code> attribute on {{MathMLElement("math")}} elements has been removed ({{bug(1573438)}}).</li>
 <li>Non-zero unitless length values, such as <code>5</code> for <code>500%</code>, are no longer supported.</li>
 <li>Length values ending with a dot, such as <code>2.</code> or <code>34.px</code>, are also unsupported now.</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#Numeric_separators">Numeric separators</a> are now supported ({{Bug(1435818)}}).</li>
 <li>The {{jsxref("RelativeTimeFormat.formatToParts", "Intl.RelativeTimeFormat.formatToParts()")}} method has been implemented ({{bug(1473229)}}).</li>
 <li>The {{jsxref("BigInt.prototype.toLocaleString()")}} method has been updated to work with the <code>locales</code> and <code>options</code> parameters per the ECMAScript 402 Intl API. Also, {{jsxref("NumberFormat.format", "Intl.NumberFormat.format()")}} and {{jsxref("NumberFormat.formatToParts", "Intl.NumberFormat.formatToParts()")}} now accept {{jsxref("BigInt")}} values ({{bug(1543677)}}).</li>
 <li>Per the latest ECMAScript specification, a leading zero is now never allowed for <a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#BigInt_literal">BigInt literals</a>, making <code>08n</code> and <code>09n</code> invalid similar to the existing error when legacy octal numbers like <code>07n</code> are used. Always use a leading zero with the letter "o" (lowercase or uppercase) for octal <code>BigInt</code> numbers (i.e. <code>0o755n</code> instead of <code>0755n</code>). See {{bug(1568619)}}.</li>
 <li>The Unicode extension key "nu" is now supported for the {{jsxref("RelativeTimeFormat", "Intl.RelativeTimeFormat")}} constructor and the {{jsxref("RelativeTimeFormat.resolvedOptions", "Intl.RelativeTimeFormat.resolvedOptions()")}} method now also returns <code>numberingSystem</code> ({{bug(1521819)}}).</li>
</ul>

<h3 id="APIs">APIs</h3>

<h4 id="DOM">DOM</h4>

<ul>
 <li>The {{domxref("History.back","back()")}}, {{domxref("History.forward","forward()")}}, and {{domxref("History.go","go()")}} methods are now asynchronous. Add a listener to the <code>{{domxref("Document/defaultView/popstate_event", "popstate")}}</code> event to get notification that navigation has completed {{Bug(1563587)}}.</li>
 <li>We've added support {{DOMxRef("DOMMatrix")}}, {{DOMxRef("DOMPoint")}}, etc. in web workers ({{bug(1420580)}}).</li>
 <li>A few more members have been moved from {{domxref("HTMLDocument")}} to {{domxref("Document")}}, including  {{domxref("Document.all")}}, {{domxref("Document.clear")}}, {{domxref("Document.captureEvents")}}, and {{domxref("Document.clearEvents")}} ({{bug(1558570)}}, {{bug(1558571)}}).</li>
 <li><a href="/en-US/docs/Web/API/Notifications_API">Notification</a> permission can no longer be requested from inside a cross-origin {{htmlelement("iframe")}} ({{bug(1560741)}}).</li>
</ul>

<h4 id="Media_Web_Audio_and_WebRTC">Media, Web Audio, and WebRTC</h4>

<ul>
 <li>The {{domxref("RTCPeerConnection.restartIce()")}} method has been added. This is one of the four changes needed to implement the new "perfect negotiation" mechanism; the rest will come in future Firefox updates ({{bug(1551316)}}).</li>
 <li>The {{domxref("RTCPeerConnection.setRemoteDescription()")}} method can now be called with no parameters. This is another "perfect negotiation" update ({{bug(1568292)}}).</li>
 <li>{{domxref("MediaTrackSupportedConstraints.groupId")}} is now supported, and returns <code>true</code> since the {{domxref("MediaTrackConstraints.groupId")}} property is now supported ({{bug(1561254)}}).</li>
 <li>Several new Web Audio API features have been implemented/updated:
  <ul>
   <li>{{domxref("AudioContext.getOutputTimestamp()")}} implemented ({{bug(1324545)}}).</li>
   <li>{{domxref("AudioContext.baseLatency")}} and {{domxref("AudioContext.outputLatency")}} implemented ({{bug(1324552)}}).</li>
   <li>{{domxref("MediaElementAudioSourceNode.mediaElement")}} and {{domxref("MediaStreamAudioSourceNode.mediaStream")}} implemented ({{bug(1350973)}}).</li>
   <li>The {{domxref("ChannelMergerNode.ChannelMergerNode()", "ChannelMergerNode()")}} constructor now throws errors if you try to set <code>channelCount</code> and <code>channelCountMode</code> to invalid values ({{bug(1456263)}}).</li>
  </ul>
 </li>
</ul>

<h4 id="Canvas_and_WebGL">Canvas and WebGL</h4>

<ul>
 <li>We now support {{domxref("CanvasRenderingContext2D.getTransform()")}}, and the newer variant of {{domxref("CanvasRenderingContext2D.setTransform()")}} that accepts a matrix object as a parameter rather than multiple parameters representing the individual components of the matrix ({{bug(928150)}}).</li>
</ul>

<h3 id="HTTP">HTTP</h3>

<ul>
 <li>The default referrer policy for third-party tracking resources is now <code>strict-origin-when-cross-origin</code> when <a href="/en-US/docs/Mozilla/Firefox/Privacy/Tracking_Protection">Enhanced Tracking Protection</a> is turned on ({{bug(1569996)}}).</li>
 <li>The size of the {{httpheader("Referer")}} request header is now limited to 4 KB (4,096 bytes). If an overly long referer exceeds the defined limit, only the origin part will be sent ({{bug(1557346)}}).</li>
 <li>The <a href="/en-US/docs/Web/HTTP/Caching">HTTP cache</a> is now partitioned per the top-level document's origin ({{bug(1536058)}}).</li>
</ul>

<h4 id="Removals_2">Removals</h4>

<ul>
 <li>The {{HTTPHeader("X-Frame-Options")}} <code>allow-from <em>uri</em></code> directive has been removed. Use the {{HTTPHeader("Content-Security-Policy")}} header with the {{CSP("frame-ancestors")}} directive instead ({{bug(1301529)}}).</li>
</ul>

<h3 id="WebDriver_conformance_Marionette">WebDriver conformance (Marionette)</h3>

<ul>
 <li>Updated the <code>WebDriver:TakeScreenshot</code> command to be <a href="https://wiki.mozilla.org/Project_Fission">Fission</a> compatible. It means that content from <a href="/en-US/docs/Web/Security/Same-origin_policy">cross-origin</a> iframes is now included in a page's screenshot. Or when using it from chrome scope that the active tab's content is visible now inside the browser window. ({{bug(1559592)}}).</li>
 <li><code>WebDriver:TakeScreenshot</code> no longer accepts a list of DOM elements as used for highlighting ({{bug(1575511)}}).</li>
 <li><code>WebDriver:ExecuteScript</code> and <code>WebDriver:ExecuteAsyncScript</code> no longer sets <code>window.onunload</code> in ways that are web-exposed ({{bug(1568991)}}).</li>
</ul>

<h2 id="Changes_for_add-on_developers">Changes for add-on developers</h2>

<h3 id="API_changes">API changes</h3>

<ul>
 <li>Added a new parameter to the <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/topSites/get">topSites.get()</a></code> method that causes the method to return the list of pages that appear when the user opens a new tab ({{bug(1568617)}}).</li>
 <li>The <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/privacy/network">privacy.network</a></code> property's <code>WebRTCIPHandlingPolicy</code> sub-property's permitted values have been amended (in {{bug(1452713)}}) to match the behavior seen in Chrome as follows:
  <ul>
   <li><code>disable_non_proxied_udp</code> previously prevented the use of WebRTC if no proxy was configured. Now a proxy is always used if one is configured, but otherwise a non-proxied connection is permitted.</li>
   <li><code>proxy_only</code> can be used to provide the old behavior; this has the effect of only allowing ICE negotiation over TURN on TCP using a proxy; no other connections are allowed.</li>
  </ul>
 </li>
</ul>

<h3 id="Manifest_changes">Manifest changes</h3>

<h4 id="Removals_3">Removals</h4>

<p>The following <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/manifest.json/theme">theme</a> key properties, which provided aliases for theme keys used in chromium-based browsers, were removed:</p>

<ul>
 <li><code>images</code> property <code>headerURL</code>, themes should now use <code>theme_frame</code>.</li>
 <li><code>colors</code> properties:
  <ul>
   <li><code>accentcolor</code>, themes should now use <code>frame</code>.</li>
   <li><code>textcolor</code>, themes should now use <code>tab_background_text</code>.</li>
  </ul>
 </li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>Hacks release post: <a href="https://hacks.mozilla.org/2019/10/firefox-70-a-bountiful-release-for-all/">Firefox 70 — a bountiful release for all</a></li>
 <li><a href="https://www.fxsitecompat.com/en-CA/versions/70/">Site compatibility for Firefox 70</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(69)}}</p>
